using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security.Cryptography;
using System.Threading;

namespace DupFinder
{
    public class Program
    {
        public void Run1(string path)
        {
            FileUtils util = new FileUtils();
            List<string> files = new List<string>();
            util.GetFileList(path, ref files);

            DupFinderCore1 p = new DupFinderCore1();

            p.FindDuplicates(files);
            OutputDuplicates(p.Hash);
        }

        public void Run2(string path)
        {
            FileUtils util = new FileUtils();
            List<string> files = new List<string>();
            util.GetFileList(path, ref files);

            DupFinderCore2 p = new DupFinderCore2();

            p.FindDuplicates(files);
            OutputDuplicates(p.Hash);
        }

        public void Run3(string path)
        {
            DupFinderCore3 p = new DupFinderCore3();

            p.FindDuplicates(path);            
        }

        private void OutputDuplicates(Hashtable hash) 
        {
            foreach (DictionaryEntry entry in hash)
            {
                List<FileDataDefinition> l = entry.Value as List<FileDataDefinition>;

                if (l.Count > 1)
                {
                    string s = string.Empty;

                    foreach (FileDataDefinition def in l)
                    {
                        s = string.Concat(s, def.FilePath, "\t");
                    }

                    Console.WriteLine("{0} \t {1} \t {2} \t {3}", l.Count, l[0].FileName, l[0].FileSize, s);
                }
            }
        }

        /// <summary>
        /// Command line options:
        /// 1   Sequential 
        /// 2   ThreadPool
        /// 3   Producer-Consumer
        /// </summary>
        static void Main(string[] args)
        {
            string path = @"C:\";
            Program p = new Program();

            DateTime t1 , t2;

            if (args.Length > 0)
            {
                switch (args[0])
                {
                    case "1":
                        t1 = DateTime.Now;
                        p.Run1(path);
                        t2 = DateTime.Now;
                        Console.WriteLine("Time = {0}s", t2 - t1);
                        break;
                    case "2":
                        t1 = DateTime.Now;
                        p.Run2(path);
                        t2 = DateTime.Now;
                        Console.WriteLine("Time = {0}s", t2 - t1);
                        break;
                    case "3":
                        t1 = DateTime.Now;
                        p.Run3(path);
                        t2 = DateTime.Now;
                        Console.WriteLine("Time = {0}s", t2 - t1);
                        break;
                }
            }
        }
    }
}
