using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Security.Cryptography;
using System.Text;

namespace DupFinder
{
    /// <summary>
    /// http://www.kerrywong.com
    /// </summary>
    public class DupFinderCore1
    {
        private Hashtable _hash = new Hashtable();

        public Hashtable Hash
        {
            get
            {
                return _hash;
            }
            set
            {
                _hash = value;
            }
        }

        public void FindDuplicates(List<string> files)
        {
            foreach (string fn in files)
            {
                string h = ComputeMD5(fn);

                if (h != string.Empty)
                {
                    FileDataDefinition def = new FileDataDefinition();
                    def.FileName = Path.GetFileName(fn);
                    def.FilePath = Path.GetDirectoryName(fn);
                    def.LastModifiedDate = Directory.GetLastWriteTime(fn);

                    FileInfo fileInfo = new FileInfo(fn);
                    def.FileSize = fileInfo.Length;

                    if (Hash.Contains(string.Concat(def.FileName, ":", h)))
                    {
                        List<FileDataDefinition> l = Hash[string.Concat(def.FileName, ":", h)] as List<FileDataDefinition>;
                        l.Add(def);

                        Hash[string.Concat(def.FileName, ":", h)] = l;
                    }
                    else
                    {
                        List<FileDataDefinition> l = new List<FileDataDefinition>();
                        l.Add(def);
                        Hash.Add(string.Concat(def.FileName, ":", h), l);
                    }
                }
            }
        }

        public string ComputeMD5(string fileName)
        {
            MD5 md5 = new MD5CryptoServiceProvider();
            byte[] hash = null;

            FileStream fs = null;

            try
            {
                fs = new FileStream(fileName, FileMode.Open);
                hash = md5.ComputeHash(fs);
            }
            catch
            {
            }
            finally
            {
                if (fs != null)
                {
                    fs.Close();
                }
            }

            if (hash != null)
                return Convert.ToBase64String(hash);
            else
                return string.Empty;

        }
    }
}
